module LittleFinger
  module Configuration
    @@conf = nil

    def self.configure_with(environment_name, yaml_file = nil)
      @@yaml_file = yaml_file.nil? ? "config/little_finger.yml" : yaml_file
      @@all_conf = Hashie::Mash.new(YAML.load_file(@@yaml_file) )
      @@conf = @@all_conf[environment_name]
      self
    end

    def self.configuration
      self.configure_with(self.environment) if @@conf.nil?
      @@conf
    end

    def self.environment
      val = ENV["RAILS_ENV"] || ENV["RACK_ENV"]
      val = if val.present?
              val.to_sym
            else
              if defined?(Rails)
                Rails.env
              else
                raise "No environment can be found for configuration!"
              end
            end
    end

  end
end